#
# Conditional build:
%bcond_without	python2	# CPython 2.x modules
%bcond_without	python3	# CPython 3.x modules

Summary:	Python bindings generator for C++ class libraries
Summary(pl.UTF-8):	Generator powiązań Pythona z bibliotekami klas C++
Name:		sip
Version:	4.19.19
Release:	2
Epoch:		2
License:	SIP (redistributable, see LICENSE) or GPL v2 or GPL v3
Group:		Development/Languages/Python
Source0:	https://www.riverbankcomputing.com/static/Downloads/sip/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	98111479309dc472410f26080d6d4a88
URL:		http://www.riverbankcomputing.com/software/sip/
BuildRequires:	libstdc++-devel
BuildRequires:	python-devel >= 1:2.3
BuildRequires:	python3-devel >= 1:3.2
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.167
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sipfilesdir	%{_datadir}/sip

%description
SIP generates Python bindings for C++ class libraries from a set of
class specification files. It supports Python v2 and v3.

%description -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Obsługiwany jest Python 2 i 3.

%package -n python-sip
Summary:	Python 2 module needed by SIP generated bindings
Summary(pl.UTF-8):	Moduł Pythona 2 wymagany przez wiązania wygenerowane przez SIP
Group:		Libraries/Python
Requires:	python-libs

%description -n python-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 2 runtime
library needed by all generated bindings.

%description -n python-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 2
potrzebną do uruchomienia wszystkich wygenerowanych powiązań.

%package -n python-sip-devel
Summary:	Python 2 development files needed to build bindings using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 2 potrzebne do budowania wiązań przy użyciu SIP-a
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	python-devel >= 1:2.3

%description -n python-sip-devel
Python 2 development files needed to build bindings for C++ classes
using SIP.

%description -n python-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 2 potrzebne do budowania wiązań dla klas
C++ przy użyciu SIP-a.

%package -n python-PyQt5-sip
Summary:	Python 2 module needed by SIP generated bindings for PyQt5
Summary(pl.UTF-8):	Moduł Pythona 2 wymagany przez wiązania wygenerowane przez SIP dla PyQt5
Group:		Libraries/Python
Requires:	python-libs

%description -n python-PyQt5-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 2 runtime
library needed by all generated bindings for PyQt5.

%description -n python-PyQt5-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 2
potrzebną do uruchomienia wszystkich wygenerowanych wiązań dla PyQt5.

%package -n python-PyQt5-sip-devel
Summary:	Python 2 development files needed to build bindings for PyQt5 using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 2 potrzebne do budowania wiązań dla PyQt5 przy użyciu SIP-a
Group:		Development/Libraries
Requires:	python-PyQt5-sip = %{epoch}:%{version}-%{release}
Requires:	python-sip-devel = %{epoch}:%{version}-%{release}

%description -n python-PyQt5-sip-devel
Python 2 development files needed to build bindings for C++ classes
for PyQt5 using SIP.

%description -n python-PyQt5-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 2 potrzebne do budowania wiązań dla klas
C++ dla PyQt5 przy użyciu SIP-a.

%package -n python3-sip
Summary:	Python 3 module needed by SIP generated bindings
Summary(pl.UTF-8):	Moduł Pythona 3 wymagany przez wiązania wygenerowane przez SIP
Group:		Libraries/Python
Requires:	python3-libs

%description -n python3-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 3 runtime
library needed by all generated bindings.

%description -n python3-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 3
potrzebną do uruchomienia wszystkich wygenerowanych powiązań.

%package -n python3-sip-devel
Summary:	Python 3 development files needed to build bindings using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 3 potrzebne do budowania wiązań przy użyciu SIP-a
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	python3-sip = %{epoch}:%{version}-%{release}
Requires:	python3-devel >= 1:3.2

%description -n python3-sip-devel
Python 3 development files needed to build bindings for C++ classes
using SIP.

%description -n python3-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 3 potrzebne do budowania wiązań dla klas
C++ przy użyciu SIP-a.

%package -n python3-PyQt5-sip
Summary:	Python 3 module needed by SIP generated bindings for PyQt5
Summary(pl.UTF-8):	Moduł Pythona 3 wymagany przez wiązania wygenerowane przez SIP dla PyQt5
Group:		Libraries/Python
Requires:	python3-libs

%description -n python3-PyQt5-sip
SIP generates Python bindings for C++ class libraries from a set of
class specification files. This package includes Python 2 runtime
library needed by all generated bindings for PyQt5.

%description -n python3-PyQt5-sip -l pl.UTF-8
SIP generuje powiązania Pythona z bibliotekami klas C++ ze zbioru
plików ze specyfikacjami klas. Ten pakiet zawiera bibliotekę Pythona 2
potrzebną do uruchomienia wszystkich wygenerowanych wiązań dla PyQt5.

%package -n python3-PyQt5-sip-devel
Summary:	Python 3 development files needed to build bindings for PyQt5 using SIP
Summary(pl.UTF-8):	Pliki programistyczne Pythona 3 potrzebne do budowania wiązań dla PyQt5 przy użyciu SIP-a
Group:		Development/Libraries
Requires:	python3-PyQt5-sip = %{epoch}:%{version}-%{release}
Requires:	python3-sip-devel = %{epoch}:%{version}-%{release}

%description -n python3-PyQt5-sip-devel
Python 3 development files needed to build bindings for C++ classes
for PyQt5 using SIP.

%description -n python3-PyQt5-sip-devel -l pl.UTF-8
Pliki programistyczne Pythona 3 potrzebne do budowania wiązań dla klas
C++ dla PyQt5 przy użyciu SIP-a.

%prep
%setup -q

%build
# configure.py notes:
# - macros overrides must be last
# - cannot pass CXXFLAGS+="%{rpmcflags}" or so - builtin -O2 overrides rpmcflags

%if %{with python2}
install -d build-py2
cd build-py2
%{__python} ../configure.py \
	-b %{_bindir} \
	-e %{py_incdir} \
	-v %{_sipfilesdir} \
	-d %{py_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..

install -d build-py2-PyQt5
cd build-py2-PyQt5
%{__python} ../configure.py \
	--sip-module=PyQt5.sip \
	-b %{_bindir} \
	-e %{py_incdir} \
	-v %{_sipfilesdir} \
	-d %{py_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..
%endif

%if %{with python3}
install -d build-py3
cd build-py3
%{__python3} ../configure.py \
	-b %{_bindir} \
	-e %{py3_incdir} \
	-v %{_sipfilesdir} \
	-d %{py3_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..

install -d build-py3-PyQt5
cd build-py3-PyQt5
%{__python3} ../configure.py \
	--sip-module=PyQt5.sip \
	-b %{_bindir} \
	-e %{py3_incdir} \
	-v %{_sipfilesdir} \
	-d %{py3_sitedir} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags}" \
	LINK="%{__cxx}" \
	LINK_SHLIB="%{__cxx}"

%{__make}
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sipfilesdir}

%if %{with python2}
%{__make} -C build-py2 install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} -C build-py2-PyQt5 install \
	DESTDIR=$RPM_BUILD_ROOT

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%{__rm} -r $RPM_BUILD_ROOT%{py_sitedir}/{sip,PyQt5_sip}-%{version}.dist-info
%endif

%if %{with python3}
%{__make} -C build-py3 install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} -C build-py3-PyQt5 install \
	DESTDIR=$RPM_BUILD_ROOT

%py3_comp $RPM_BUILD_ROOT%{py3_sitedir}
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitedir}
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitedir}/{sip,PyQt5_sip}-%{version}.dist-info
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE NEWS README doc/html
%attr(755,root,root) %{_bindir}/sip
%dir %{_sipfilesdir}

%if %{with python2}
%files -n python-sip
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/sip.so

%files -n python-sip-devel
%defattr(644,root,root,755)
%{py_sitedir}/sipconfig.py
%{py_sitedir}/sipconfig.py[co]
%{py_sitedir}/sipdistutils.py
%{py_sitedir}/sipdistutils.py[co]
%{py_sitedir}/sip.pyi
%{py_incdir}/sip.h

%files -n python-PyQt5-sip
%defattr(644,root,root,755)
%dir %{py_sitedir}/PyQt5
%attr(755,root,root) %{py_sitedir}/PyQt5/sip.so

%files -n python-PyQt5-sip-devel
%defattr(644,root,root,755)
%{py_sitedir}/PyQt5/sip.pyi
%endif

%if %{with python3}
%files -n python3-sip
%defattr(644,root,root,755)
%attr(755,root,root) %{py3_sitedir}/sip.so

%files -n python3-sip-devel
%defattr(644,root,root,755)
%{py3_sitedir}/sipconfig.py
%{py3_sitedir}/sipdistutils.py
%{py3_sitedir}/__pycache__/sipconfig.cpython-*.py[co]
%{py3_sitedir}/__pycache__/sipdistutils.cpython-*.py[co]
%{py3_sitedir}/sip.pyi
%{py3_incdir}/sip.h

%files -n python3-PyQt5-sip
%defattr(644,root,root,755)
%dir %{py3_sitedir}/PyQt5
%attr(755,root,root) %{py3_sitedir}/PyQt5/sip.so

%files -n python3-PyQt5-sip-devel
%defattr(644,root,root,755)
%{py3_sitedir}/PyQt5/sip.pyi
%endif
%changelog
* Mon Oct 28 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sip.git;a=log;h=master

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 4d268a2
- rebuild with python 3.8
- release 2 (by relup.sh)

* Wed Sep 25 2019 Jan Palus <atler@pld-linux.org> 78af538
- up to 4.19.19

* Tue Jul 30 2019 Jakub Bogusz <qboosh@pld-linux.org> 6e8f53e
- separate -PyQt5-sip-devel, let -sip-devel don't depend on -PyQt5-sip

* Sat Jul 06 2019 Jan Palus <atler@pld-linux.org> c8f1730
- up to 4.19.18

* Sat Apr 13 2019 Jan Palus <atler@pld-linux.org> 7ce55b3
- up to 4.19.16

* Wed Mar 20 2019 Jan Palus <atler@pld-linux.org> b442147
- up to 4.19.15

* Wed Mar 13 2019 Jan Rękorajski <baggins@pld-linux.org> 68611d3
- release 2 (by relup.sh)

* Fri Mar 01 2019 Jan Palus <atler@pld-linux.org> f1f625e
- up to 4.19.14

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> 2e7a113
- rel 8

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> d25da5c
- revert "make non-Qt namespaced install be default for devel packages"

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> 7332c9c
- make non-Qt namespaced install be default for devel packages
- rel 7

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> 57fb065
- updated deps and files
- rel 6

* Sun Nov 04 2018 Jan Rękorajski <baggins@pld-linux.org> 89f5b16
- build non-QT namespaced python modules
- rel 5

* Sun Aug 12 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 34ad956
- drop from files, too

* Sun Aug 12 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> af1fb71
- rel 4; revert __init__.py creation as python-PyQt5 provides it

* Sat Aug 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 7789ab1
- rel 3; allow on python2: from PyQt5 import sip

* Sat Aug 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> c0d3d5b
- rel 2; use PyQt5 module name

* Sun Jul 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 02ea3c4
- updated to 4.19.12
- removed obsolete outoftree patch

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1c272ed
- release 2 (by relup.sh)

* Sat Jul 08 2017 Witold Filipczyk <witekfl@poczta.onet.pl> 0772d9f
- updated to 4.19.3

